import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Editor extends Applet {
	private static final int MAX_OBJ = 16;
	private Button sel = new Button("Selection");
	private Button del = new Button("Delete object");
	private Button line = new Button("Line");
	private Button rect = new Button("Rectangle");
	private Button ellipse = new Button("Ellipse");
	private Choice borderWidth = new Choice();
	private	Choice borderColor = new Choice();
	private	Choice fillColor = new Choice();
	private int curborderColor = 0;
	private int curfillColor = 2;
	private int curborderWidth = 0;
	private	Panel panel = new Panel();
	private	Panel panel2 = new Panel();
	private Label labelX = new Label("      ");
	private Label labelY = new Label("      ");
	private Label lmode = new Label("selection");
	private EditorCanvas canvas;
	private int mode;
	private GraphicObject obj[] = new GraphicObject[16];
	private GraphicObject active = null, selected = null;
	private int t_x, t_y, move_mode = 0;
	public void init()					  
	{
		for (int i = 0; i < MAX_OBJ; i++)
			obj[i] = null;
		canvas = new EditorCanvas(obj);
		mode = 0;
		resize(640, 400);
		setLayout(new BorderLayout());
		panel.add(sel);
		panel.add(del);
		panel.add(line);
		panel.add(rect);
		panel.add(ellipse);
		sel.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					lmode.setText("selection");
					mode = 0;
					canvas.SetSelection(null);
					selected = null;
				}
			}
		);
		del.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if (selected == null) return;

					int i = 0;
					for (; i < MAX_OBJ; i++)
						if (obj[i] == selected)
						{
							obj[i] = null;
							break;
						}

					for (i++; i < MAX_OBJ; i++)
						obj[i - 1] = obj[i];

					obj[i - 1] = null;
					selected = null;
					canvas.SetSelection(null);
					canvas.repaint();
				}
			}
		);
		line.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					lmode.setText("line");
					mode = 1;
					canvas.SetSelection(null);
					selected = null;
				}
			}
		);
		rect.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					lmode.setText("rectangle");
					mode = 2;
					canvas.SetSelection(null);
					selected = null;
				}
			}
		);
		ellipse.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					lmode.setText("ellipse");
					mode = 3;
					canvas.SetSelection(null);
					selected = null;
				}
			}
		);
		panel.add(new Label("Border width:"));
		panel.add(borderWidth);
		panel.add(new Label("Current mode:"));
		panel.add(lmode);
		panel2.add(new Label("Border color:"));
		panel2.add(borderColor);
		panel2.add(new Label("Fill color:"));
		panel2.add(fillColor);
		panel2.add(new Label("Mouse X:"));
		panel2.add(labelX);
		panel2.add(new Label("Mouse Y:"));
		panel2.add(labelY);
		borderColor.addItem("Black");
		borderColor.addItem("Navy");
		borderColor.addItem("Green");
		borderColor.addItem("Teal");
		borderColor.addItem("Red");
		borderColor.addItem("Purple");
		borderColor.addItem("Maroon");
		borderColor.addItem("Silver");
		borderColor.addItem("Gray");
		borderColor.addItem("Blue");
		borderColor.addItem("Lime");
		borderColor.addItem("Aqua");
		borderColor.addItem("Olive");
		borderColor.addItem("Fuchsia");
		borderColor.addItem("Yellow");
		borderColor.addItem("White");	
		borderColor.select(curborderColor);
		fillColor.addItem("Black");
		fillColor.addItem("Navy");
		fillColor.addItem("Green");
		fillColor.addItem("Teal");
		fillColor.addItem("Red");
		fillColor.addItem("Purple");
		fillColor.addItem("Maroon");
		fillColor.addItem("Silver");
		fillColor.addItem("Gray");
		fillColor.addItem("Blue");
		fillColor.addItem("Lime");
		fillColor.addItem("Aqua");
		fillColor.addItem("Olive");
		fillColor.addItem("Fuchsia");
		fillColor.addItem("Yellow");
		fillColor.addItem("White");	
		fillColor.select(curfillColor);
		borderColor.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					curborderColor = borderColor.getSelectedIndex();
					if (selected != null)
						if (selected.getborderColor() != curborderColor)
						{
							selected.SetBorderColor(curborderColor);
							canvas.repaint();
						}
				}
			}
		);
		fillColor.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					curfillColor = fillColor.getSelectedIndex();
					if (selected != null)
						if (selected.getfillColor() != curfillColor)
						{
							selected.SetFillColor(curfillColor);
							canvas.repaint();
						}
				}
			}
		);
		borderWidth.addItem("1");
		borderWidth.addItem("2");
		borderWidth.addItem("3");
		borderWidth.addItem("4");
		borderWidth.addItem("5");
		borderWidth.addItem("6");
		borderWidth.addItem("7");
		borderWidth.addItem("8");
		borderWidth.addItem("9");
		borderWidth.addItem("10");
		borderWidth.select(curborderWidth);
		borderWidth.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					curborderWidth = borderWidth.getSelectedIndex();
					if (selected != null)
						if (selected.getborderWidth() != curborderWidth)
						{
							selected.SetBorderWidth(curborderWidth);
							canvas.repaint();
						}
				}
			}
		);
		add("North", panel);
		add("South", panel2);
		canvas.addMouseListener(
			new MouseAdapter()
			{
				public void mouseExited(MouseEvent e)
				{
					labelX.setText("      ");
					labelY.setText("      ");
				}
				public void mousePressed(MouseEvent e)
				{
					t_x = e.getX();
					t_y = e.getY();

					if (mode != 0)
						AddNewObj(t_x, t_y);
					else
					{
						if (selected != null)
						{
							int x = selected.getX();
							int y = selected.getY();
							int w = selected.getW();
							int h = selected.getH();

							if (t_x > x - 5 && t_y > y - 5 && t_x < x + 5 && t_y < y + 5)
								move_mode = 1;
							else if	(t_x > x + w - 5 && t_y > y - 5 && t_x < x + w + 5 && t_y < y + 5)
								move_mode = 2;
							else if	(t_x > x - 5 && t_y > y + h - 5 && t_x < x + 5 && t_y < y + h + 5)
								move_mode = 3;
							else if	(t_x > x + w - 5 && t_y > y + h - 5 && t_x < x + w + 5 && t_y < y + h + 5)
								move_mode = 4;
							else if (t_x > x && t_y > y && t_x < x && t_y < y)
								move_mode = 0;
							else
								FindObject(t_x, t_y);
						}
						else
							FindObject(t_x, t_y);
					}
				}
				public void mouseReleased(MouseEvent e)
				{
					active = null;
					move_mode = 0;
				}
			}
		);
		canvas.addMouseMotionListener(
			new MouseMotionAdapter()
			{
				public void mouseMoved(MouseEvent e)
				{
					labelX.setText("" + e.getX());
					labelY.setText("" + e.getY());
				}
				public void mouseDragged(MouseEvent e)
				{
					labelX.setText("" + e.getX());
					labelY.setText("" + e.getY());

					if (mode > 0 && active != null)
					{
						active.SetSize(t_x, t_y, e.getX(), e.getY());
						canvas.repaint();
					}
					else
						if (selected != null)
						{
							if (move_mode == 1)
							{
								selected.changeUL(e.getX() - t_x, e.getY() - t_y);
							}
							else if (move_mode == 2)
							{
								selected.changeUR(e.getX() - t_x, e.getY() - t_y);
							}
							else if	(move_mode == 3)
							{
								selected.changeDL(e.getX() - t_x, e.getY() - t_y);
							}
							else if (move_mode == 4)
							{
								selected.changeDR(e.getX() - t_x, e.getY() - t_y);
							}
							else
							{
								selected.Move(e.getX() - t_x, e.getY() - t_y);
							}
							t_x = e.getX();
							t_y = e.getY();
							canvas.repaint();
						}
				}
			}
		);
		add("Center", canvas);
		canvas.repaint();
	}
	public void AddNewObj(int x, int y)
	{
		for (int i = 0; i < MAX_OBJ; i++)
		{
			if (obj[i] == null)
			{
				obj[i] = new GraphicObject(x, y, mode - 1, curborderColor, curfillColor, curborderWidth);
				active = obj[i];
				return;
			}
		}
		active = null;
	}
	public void FindObject(int x1, int y1)
	{
		for (int i = MAX_OBJ - 1; i >= 0; i--)
		{
			if (obj[i] == null) continue;

			int x = obj[i].getX();
			int y = obj[i].getY();
			int w = obj[i].getW();
			int h = obj[i].getH();

			if (x1 > x && y1 > y && x1 < x + w && y1 < y + h)
			{
				canvas.SetSelection(obj[i]);
				selected = obj[i];
				curborderColor = selected.getborderColor();
				borderColor.select(curborderColor);
				curfillColor = selected.getfillColor();
				fillColor.select(curfillColor);
				curborderWidth = selected.getborderWidth();
				borderWidth.select(curborderWidth);
				return;
			}
		}
		selected = null;
		canvas.SetSelection(null);
	}
}

class GraphicObject {
	private int x, y, w, h, type;
	private int xl1, yl1, xl2, yl2;
	private int borderColor, fillColor, borderWidth;
	private static Color col[] = new Color[16];
	public GraphicObject(int x1, int y1, int t, int c1, int c2, int b)
	{
		x = x1;
		y = y1;
		xl1 = x1;
		yl1 = y1;
		type = t;
		borderColor = c1;
		fillColor = c2;
		borderWidth = b;
		col[0] = new Color(0, 0, 0);
		col[1] = new Color(0, 0, 128);
		col[2] = new Color(0, 128, 0);
		col[3] = new Color(0, 128, 128);
		col[4] = new Color(128, 0, 0);
		col[5] = new Color(128, 0, 128);
		col[6] = new Color(128, 128, 0);
		col[7] = new Color(128, 128, 128);
		col[8] = new Color(192, 192, 192);
		col[9] = new Color(0, 0, 255);
		col[10] = new Color(0, 255, 0);
		col[11] = new Color(0, 255, 255);
		col[12] = new Color(255, 0, 0);
		col[13] = new Color(255, 0, 255);
		col[14] = new Color(255, 255, 0);
		col[15] = new Color(255, 255, 255);
	}
	public void SetBorderColor(int c)
	{
		borderColor = c;
	}
	public void SetFillColor(int c)
	{
		fillColor = c;
	}
	public void SetBorderWidth(int b)
	{
		borderWidth = b;
	}
	public void SetSize(int x1, int y1, int x2, int y2)
	{
		xl2 = x2;
		yl2 = y2;
		
		if (x2 < x1)
		{
			x = x2;
			w = x1 - x2;
		}
		else
		{
			x = x1;
			w = x2 - x1;
		}

		if (y2 < y1)
		{
			y = y2;
			h = y1 - y2;
		}
		else
		{
			y = y1;
			h = y2 - y1;
		}
	}
	public void Move(int dx, int dy)
	{
		x += dx;
		y += dy;
		xl1 += dx;
		xl2 += dx;
		yl1 += dy;
		yl2 += dy;
	}
	public void Draw(Graphics g)
	{
		g.setColor(col[borderColor]);
		switch (type)
		{
			case 0: 
				g.drawLine(xl1, yl1, xl2, yl2); break;			
			case 1: 
				g.fillRect(x, y, w, h); 
				g.setColor(col[fillColor]);
				g.fillRect(x + borderWidth + 1, y + borderWidth + 1, w - 2 - borderWidth * 2, h - 2 - borderWidth * 2);			
				break;
			case 2: 
				g.fillOval(x, y, w, h);
				g.setColor(col[fillColor]);
				g.fillOval(x + borderWidth + 1, y + borderWidth + 1, w - 2 - borderWidth * 2, h - 2 - borderWidth * 2);			
				break;
		}
	}
	public int getX() { return x; }
	public int getY() { return y; }
	public int getW() { return w; }
	public int getH() { return h; }
	public int getborderColor() { return borderColor; }
	public int getfillColor() { return fillColor; }
	public int getborderWidth() { return borderWidth; }
	public void changeUL(int dx, int dy)
	{
		if (dx > w || dy > h) return;
		x += dx;
		y += dy;
		w -= dx;
		h -= dy;
		if (xl1 > xl2) xl2 += dx; else xl1 += dx;
		if (yl1 > yl2) yl2 += dy; else yl1 += dy;
	}
	public void changeUR(int dx, int dy)
	{
		if (dx < -w || dy > h) return;
		w += dx;
		y += dy;
		h -= dy;
		if (xl1 < xl2) xl2 += dx; else xl1 += dx;
		if (yl1 > yl2) yl2 += dy; else yl1 += dy;
	}
	public void changeDL(int dx, int dy)
	{
		if (dx > w || dy < -h) return;
		x += dx;
		w -= dx;
		h += dy;
		if (xl1 > xl2) xl2 += dx; else xl1 += dx;
		if (yl1 < yl2) yl2 += dy; else yl1 += dy;
	}
	public void changeDR(int dx, int dy)
	{
		if (dx < -w || dy < -h) return;
		w += dx;
		h += dy;
		if (xl1 < xl2) xl2 += dx; else xl1 += dx;
		if (yl1 < yl2) yl2 += dy; else yl1 += dy;
	}
}

class EditorCanvas extends Canvas {
	private GraphicObject obj[] = null;
	private static final int MAX_OBJ = 16;
	private Graphics buf;
	private Image i;
	private Dimension d;
	private GraphicObject sel = null;
	public EditorCanvas(GraphicObject o[])
	{
		super();
		obj = o;
	}
	public void paint(Graphics g)
	{
		if (i != null)
			g.drawImage(i, 0, 0, null);
	}
	public void update(Graphics g)
	{
		Rectangle dim = g.getClipBounds();
		
		if (d == null || d.width != dim.width || d.height != dim.height)
		{
			i = createImage(dim.width, dim.height);
			d = new Dimension(dim.width, dim.height);
			buf = i.getGraphics();		
		}

		buf.setColor(Color.white);
		buf.fillRect(0, 0, dim.width, dim.height);		
		for (int i = 0; i < MAX_OBJ; i++)
			if (obj[i] != null)
				obj[i].Draw(buf);
	
		DrawSelection(buf);

		paint(g);
	} 
	public void SetSelection(GraphicObject o)
	{
		if (sel != o)
		{
			sel = o;
			repaint();
		}
		else
			sel = o;
	}
	public void DrawSelection(Graphics g)
	{
		if (sel == null) return;

		int x = sel.getX();
		int y = sel.getY();
		int w = sel.getW();
		int h = sel.getH();

		g.setColor(Color.black);
		g.fillRect(x - 5, y - 5, 10, 10);
		g.fillRect(x + w - 5, y + h - 5, 10, 10);
		g.fillRect(x + w - 5, y - 5, 10, 10);
		g.fillRect(x - 5, y + h - 5, 10, 10);
	}
}
